diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 5bbd895c..2c22886c 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -203,214 +167,334 @@ class SquadService extends Actor {
       //send initial squad catalog
       sender ! SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(publishedLists(PlanetSideEmpire(faction)).toVector))
 
-    //subscribe to the player's personal channel - necessary only to inform about any previous squad association
+    //subscribe to the player's personal channel - necessary for future and previous squad information
     case Service.Join(char_id) =>
       val path = s"/$char_id/Squad"
       val who = sender()
       log.info(s"$who has joined $path")
-      SquadEvents.subscribe(who, path) //TODO squad-specific switchboard
+      SquadEvents.subscribe(who, path)
       //check for renewable squad information
-      memberToSquad.get(char_id.toLong) match {
-        case None => ;
-        case Some(_) =>
-          sender ! SquadServiceMessage.RecoverSquadMembership() //TODO?
-      }
-
-    case Service.Leave(Some(char_id)) => ;
-      SquadEvents.unsubscribe(sender())
       val longCharId = char_id.toLong
       memberToSquad.get(longCharId) match {
-        case Some(squad) =>
-          if(squad.Leader.Name.equals(char_id)) {
-            //we were the leader
-            if(squad.Membership.count(p => p.Name.equals("")) > 1) {
-              //other players were in the squad; publicly disband it
-              squad.Membership.foreach(position => {
-                position.Name = ""
-                position.CharId = 0L
-                position.ZoneId = 0
-                position.Position = Vector3.Zero
-                position.Health = 0
-                position.Armor = 0
-              })
-            }
-            memberToSquad.remove(longCharId)
-            idToSquad.remove(squad.GUID)
-            UpdateSquadList(squad, None)
-          }
-          else {
-            //we were just a grunt in the squad
-            val position = squad.Membership.find(_.CharId == longCharId).get
-            position.Name = ""
-            position.ZoneId = 0
-            position.Position = Vector3.Zero
-            position.Health = 0
-            position.Armor = 0
-            UpdateSquadDetail(squad.GUID, squad)
-          }
         case None => ;
+        case Some(squad) =>
+          val guid = squad.GUID
+          val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+          SquadEvents.publish(SquadServiceResponse(s"/$char_id/Squad", SquadResponse.AssociateWithSquad(guid)))
+          SquadEvents.publish(SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Join(squad, indices)))
+          InitSquadDetail(guid, Seq(longCharId), squad)
+          InitWaypoints(longCharId, guid)
       }
-    //TODO leave squad, if joined to one, and perform clean-up
+
+    case Service.Leave(Some(char_id)) =>
+      SquadEvents.unsubscribe(sender())
+      val longCharId = char_id.toLong
+      val pSquadOpt = GetParticipatingSquad(longCharId)
+      (pSquadOpt, GetLeadingSquad(longCharId, pSquadOpt)) match {
+        case (Some(_), Some(squad)) =>
+          //leader of a squad; the squad will be disbanded
+          DisbandSquad(squad)
+        case (Some(squad), None) if squad.Size == 2 =>
+          //one of the last two members of a squad; the squad will be disbanded
+          DisbandSquad(squad)
+        case (Some(squad), None) =>
+          //member of the squad; leave the squad
+          LeaveSquad(longCharId, squad)
+        case _ =>
+          //not a member of any squad; nothing to do here
+      }
+      CleanupInvitesFromPlayer(longCharId)
 
     case Service.Leave(None) | Service.LeaveAll() => ;
 
-    case SquadServiceMessage(tplayer, squad_action) => squad_action match {
+    case SquadServiceMessage(tplayer, zone, squad_action) => squad_action match {
       case SquadAction.Membership(SquadRequestType.Invite, invitingPlayer, Some(invitedPlayer), _, _) =>
         //this is just busy work; for actual joining operations, see SquadRequestType.Accept
-        //for the purposes of this code, tplayer.CharId == invitingPlayer
-//        FindBid(invitingPlayer, invitedPlayer) match {
-//          case Some(bid) =>
-//            //invitingPlayer and invitedPlayer have both tried to join each others's squads
-//            //treat this junction as consent
-//            self ! SquadServiceMessage(tplayer, SquadAction.Membership(SquadRequestType.Accept, invitingPlayer, Some(invitedPlayer), "", None))
-//          case _ => ;
-//        }
         (memberToSquad.get(invitingPlayer), memberToSquad.get(invitedPlayer)) match {
           case (Some(squad1), Some(squad2))
             if squad1.GUID == squad2.GUID =>
-          //both players are in the same squad; no need to do anything
+            //both players are in the same squad; no need to do anything
 
           case (Some(squad1), Some(squad2))
             if squad1.Leader.CharId == invitingPlayer && squad2.Leader.CharId == invitedPlayer &&
               squad1.Size > 1 && squad2.Size > 1 =>
-          //we might do some platoon chicanery with this case later
-          // TODO platoons
+            //we might do some platoon chicanery with this case later
+            //TODO platoons
 
-          case (Some(squad1), Some(squad2)) if squad2.Size == 1 =>
-          //both players belong to squads, but the invitedplayer's squad is underutilized by comparison
-          //treat the same as "the classic situation" using squad1
+          case (Some(squad1), Some(squad2))
+            if squad2.Size == 1 && !squadFeatures(squad1.GUID).Refuse.contains(invitedPlayer) =>
+            //both players belong to squads, but the invitedplayer's squad (squad2) is underutilized by comparison
+            //treat the same as "the classic situation" using squad1
             log.info(s"$invitedPlayer has been invited to squad ${squad1.Task} by $invitingPlayer")
             val charId = tplayer.CharId
-            val bid = VacancyInvite(charId, tplayer.Name, squad1.GUID)
-            AddInvite(invitedPlayer, bid) match {
-              case out @ Some(_) if out.contains(bid) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, charId, Some(invitedPlayer), tplayer.Name, false, Some(None))))
-                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), tplayer.Name, true, Some(None))))
-              case Some(_) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), tplayer.Name, true, Some(None))))
-              case _ => ;
-            }
+            AddInviteAndRespond(
+              invitedPlayer,
+              VacancyInvite(charId, tplayer.Name, squad1.GUID),
+              charId,
+              tplayer.Name
+            )
 
-          case (Some(squad1), Some(squad2)) if squad1.Size == 1 =>
-          //both players belong to squads, but the invitingplayer's squad is underutilized by comparison
-          //treat the same as "indirection ..." using squad2
-            val leaderCharId = squad2.Leader.CharId
-            val bid = IndirectVacancy(tplayer, squad2.GUID)
-            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad2.Task}, but the squad leader needs to approve")
-            AddInvite(leaderCharId, bid) match {
-              case out @ Some(_) if out.contains(bid) =>
-                HandleBidForPosition(bid, tplayer)
-              case _ => ;
-            }
+          case (Some(squad1), Some(squad2))
+            if squad1.Size == 1 && !squadFeatures(squad2.GUID).Refuse.contains(invitingPlayer) =>
+            //both players belong to squads, but the invitingPlayer's squad is underutilized by comparison
+            //treat the same as "indirection ..." using squad2
+            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad2.Task}, but the squad leader may need to approve")
+            AddInviteAndRespond(
+              squad2.Leader.CharId,
+              IndirectInvite(tplayer, squad2.GUID),
+              invitingPlayer,
+              tplayer.Name
+            )
 
-          case (Some(squad), None) =>
+          case (Some(squad), None)
+            if !squadFeatures(squad.GUID).Refuse.contains(invitedPlayer) =>
             //the classic situation
             log.info(s"$invitedPlayer has been invited to squad ${squad.Task} by $invitingPlayer")
-            val charId = tplayer.CharId
-            val bid = VacancyInvite(charId, tplayer.Name, squad.GUID)
-            AddInvite(invitedPlayer, bid) match {
-              case out @ Some(_) if out.contains(bid) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, charId, Some(invitedPlayer), tplayer.Name, false, Some(None))))
-                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), tplayer.Name, true, Some(None))))
-              case Some(_) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(charId), tplayer.Name, true, Some(None))))
-              case _ => ;
-            }
+            AddInviteAndRespond(
+              invitedPlayer,
+              VacancyInvite(tplayer.CharId, tplayer.Name, squad.GUID),
+              invitingPlayer,
+              tplayer.Name
+            )
 
-          case (None, Some(squad)) =>
+          case (None, Some(squad))
+            if !squadFeatures(squad.GUID).Refuse.contains(invitingPlayer) =>
             //indirection;  we're trying to invite ourselves to someone else's squad
-            val leaderCharId = squad.Leader.CharId
-            val bid = IndirectVacancy(tplayer, squad.GUID)
-            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad.Task}, but the squad leader needs to approve")
-            AddInvite(leaderCharId, bid) match {
-              case out @ Some(_) if out.contains(bid) =>
-                HandleBidForPosition(bid, tplayer)
-              case _ => ;
-            }
+            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad.Task}, but the squad leader may need to approve")
+            AddInviteAndRespond(
+              squad.Leader.CharId,
+              IndirectInvite(tplayer, squad.GUID),
+              invitingPlayer,
+              tplayer.Name
+            )
 
           case (None, None) =>
             //neither the invited player nor the inviting player belong to any squad
             log.info(s"$invitedPlayer has been invited to join $invitingPlayer's spontaneous squad")
-            val bid = SpontaneousInvite(tplayer)
-            AddInvite(invitedPlayer, bid) match {
-              case out @ Some(_) if out.contains(bid) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
-                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(invitingPlayer), tplayer.Name, true, Some(None))))
-              case Some(_) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(invitingPlayer), tplayer.Name, true, Some(None))))
-              case _ => ;
+            AddInviteAndRespond(
+              invitedPlayer,
+              SpontaneousInvite(tplayer),
+              invitingPlayer,
+              tplayer.Name
+            )
+
+          case _ => ;
+        }
+
+      case SquadAction.Membership(SquadRequestType.ProximityInvite, invitingPlayer, _, _, _) =>
+        memberToSquad.get(invitingPlayer) match {
+          case Some(squad) =>
+            val sguid = squad.GUID
+            val features = squadFeatures(sguid)
+            features.SearchForRole match {
+              case Some(-1) =>
+                //we've already issued a proximity invitation; no need to do another
+                log.info("ProximityInvite: waiting for existing proximity invitations to clear")
+              case _ =>
+                log.info("ProximityInvite: looking for invitation targets ...")
+                val outstandingActiveInvites = features.SearchForRole match {
+                  case Some(pos) =>
+                    RemoveQueuedInvitesForSquadAndPosition(sguid, pos)
+                    invites.collect { case(charId, InviteForRole(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
+                  case None =>
+                    List.empty[Long]
+                }
+                features.SearchForRole = Some(-1)
+                val faction = squad.Faction
+                val center = tplayer.Position
+                val excusedInvites = features.Refuse
+                //positions that can be recruited to
+                val positions = squad.Membership.zipWithIndex
+                  .collect { case(member, index) if member.CharId == 0 && squad.Availability(index) => member }
+                /*
+                players who are:
+                - the same faction as the squad
+                - have Looking For Squad enabled
+                - do not currently belong to a squad
+                - are denied the opportunity to be invited
+                - are a certain distance from the squad leader
+                 */
+                (zone.LivePlayers
+                  .collect { case player
+                    if player.Faction == faction && player.LFS && memberToSquad.get(player.CharId).isEmpty &&
+                      !excusedInvites.contains(player.CharId) &&
+                      Vector3.DistanceSquared(player.Position, center) < 100f &&
+                      {
+                        positions
+                          .map { role =>
+                            val requirementsToMeet = role.Requirements
+                            requirementsToMeet.intersect(player.Certifications) == requirementsToMeet
+                          }
+                          .foldLeft(false)(_ || _)
+                      } => player.CharId
+                  }
+                  .partition { charId => outstandingActiveInvites.exists(_ == charId) } match {
+                  case (Nil, Nil) =>
+                    //no one found
+                    log.info("ProximityInvite: no invitation targets found")
+                    outstandingActiveInvites foreach RemoveInvite
+                    features.ProxyInvites = Nil
+                    None
+                  case (outstandingPlayerList, invitedPlayerList) =>
+                    //players who were actively invited for the previous position and are eligible for the new position
+                    log.info(s"ProximityInvite: found ${outstandingPlayerList.size} players already having been invited, and ${invitedPlayerList.size} players to invite")
+                    outstandingPlayerList.foreach { charId =>
+                      val bid = invites(charId).asInstanceOf[InviteForRole]
+                      invites(charId) = ProximityInvite(bid.char_id, bid.name, sguid)
+                    }
+                    //players who were actively invited for the previous position but are ineligible for the new position
+                    (features.ProxyInvites filterNot (outstandingPlayerList contains)) foreach RemoveInvite
+                    features.ProxyInvites = outstandingPlayerList ++ invitedPlayerList
+                    Some(invitedPlayerList)
+                }) match {
+                  //add invitations for position in squad
+                  case Some(invitedPlayers) =>
+                    val invitingPlayer = tplayer.CharId
+                    val name = tplayer.Name
+                    invitedPlayers.foreach { invitedPlayer =>
+                      AddInviteAndRespond(
+                        invitedPlayer,
+                        ProximityInvite(invitingPlayer, name, sguid),
+                        invitingPlayer,
+                        name
+                      )
+                    }
+                  case None => ;
+                }
             }
 
-          case _ => //
+          case None =>
         }
 
       case SquadAction.Membership(SquadRequestType.Accept, invitedPlayer, _, _, _) =>
         val acceptedInvite = RemoveInvite(invitedPlayer)
-        if(EnsureEmptySquad(invitedPlayer, "Accept: the invited player is already a member of a squad and can not join a second one")) {
-          acceptedInvite match {
-            case Some(BidForPosition(petitioner, guid, position)) if idToSquad.get(guid).nonEmpty =>
-              //player requested to join a squad's specific position
-              //invitedPlayer is actually the squad leader; petitioner is the actual "invitedPlayer"
-              JoinSquad(petitioner, idToSquad(guid), position)
+        val msg = "Accept: the invited player is already a member of a squad and can not join a second one"
+        acceptedInvite match {
+          case Some(BidForRole(petitioner, guid, position)) if EnsureEmptySquad(petitioner.CharId, msg) && squadFeatures.get(guid).nonEmpty =>
+            //player requested to join a squad's specific position
+            //invitedPlayer is actually the squad leader; petitioner is the actual "invitedPlayer"
+            val features = squadFeatures(guid)
+            JoinSquad(petitioner, features.Squad, position)
+            RemoveInvitesForSquadAndPosition(guid, position)
 
-            case Some(IndirectVacancy(recruit, guid)) =>
-              //tplayer / invitedPlayer is actually the squad leader
-              val recruitCharId = recruit.CharId
-              HandleVacancyInvite(guid, recruitCharId, invitedPlayer, recruit) match {
-                case Some((squad, line)) =>
-                  SquadEvents.publish(SquadServiceResponse(s"/$recruitCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(recruitCharId), "", true, Some(None))))
-                  JoinSquad(recruit, squad, line)
-                //since we are the squad leader, we do not want to brush off our queued squad invite tasks
-                case _ => ;
-              }
+          case Some(IndirectInvite(recruit, guid)) if EnsureEmptySquad(recruit.CharId, msg) =>
+            //tplayer / invitedPlayer is actually the squad leader
+            val recruitCharId = recruit.CharId
+            HandleVacancyInvite(guid, recruitCharId, invitedPlayer, recruit) match {
+              case Some((squad, line)) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(recruitCharId), recruit.Name, true, Some(None))))
+                JoinSquad(recruit, squad, line)
+                RemoveInvitesForSquadAndPosition(squad.GUID, line)
+              //since we are the squad leader, we do not want to brush off our queued squad invite tasks
+              case _ => ;
+            }
 
-            case Some(VacancyInvite(invitingPlayer, _, guid)) =>
-              //accepted an invitation to join an existing squad
-              HandleVacancyInvite(guid, invitedPlayer, invitingPlayer, tplayer) match {
-                case Some((squad, line)) =>
-                  SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
-                  SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))))
-                  JoinSquad(tplayer, squad, line)
-                  RemoveQueuedInvites(invitedPlayer) //TODO deal with these somehow
-                case _ => ;
-              }
+          case Some(VacancyInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer, msg) =>
+            //accepted an invitation to join an existing squad
+            HandleVacancyInvite(guid, invitedPlayer, invitingPlayer, tplayer) match {
+              case Some((squad, line)) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))))
+                JoinSquad(tplayer, squad, line)
+                RemoveQueuedInvites(invitedPlayer) //TODO deal with these somehow
+                RemoveInvitesForSquadAndPosition(squad.GUID, line)
+              case _ => ;
+            }
 
-            case Some(SpontaneousInvite(invitingPlayer)) =>
-              //originally, we were invited by someone into a new squad they would form
-              val invitingPlayerCharId = invitingPlayer.CharId
-              (GetParticipatingSquad(invitingPlayer) match {
-                case Some(participating) =>
-                  //invitingPlayer became part of a squad while invited player was answering the original summons
-                  Some(participating)
-                case _ =>
-                  //generate a new squad, with invitingPlayer as the leader
-                  val squad = StartSquad(invitingPlayer)
-                  squad.Task = s"${invitingPlayer.Name}'s Squad"
-                  SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.AssociateWithSquad(squad.GUID)) )
-                  Some(squad)
-              }) match {
-                case Some(squad) =>
-                  HandleVacancyInvite(squad.GUID, tplayer.CharId, invitingPlayerCharId, tplayer) match {
-                    case Some((_, line)) =>
-                      SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayerCharId), "", true, Some(None))) )
-                      JoinSquad(tplayer, squad, line)
-                      SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayerCharId, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
-                      RemoveQueuedInvites(tplayer.CharId) //TODO deal with these somehow
-                    case _ => ;
+          case Some(SpontaneousInvite(invitingPlayer)) if EnsureEmptySquad(invitedPlayer, msg) =>
+            //originally, we were invited by someone into a new squad they would form
+            val invitingPlayerCharId = invitingPlayer.CharId
+            (GetParticipatingSquad(invitingPlayer) match {
+              case Some(participating) =>
+                //invitingPlayer became part of a squad while invited player was answering the original summons
+                Some(participating)
+              case _ =>
+                //generate a new squad, with invitingPlayer as the leader
+                val squad = StartSquad(invitingPlayer)
+                squad.Task = s"${invitingPlayer.Name}'s Squad"
+                SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.AssociateWithSquad(squad.GUID)) )
+                Some(squad)
+            }) match {
+              case Some(squad) =>
+                HandleVacancyInvite(squad.GUID, tplayer.CharId, invitingPlayerCharId, tplayer) match {
+                  case Some((_, line)) =>
+                    SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayerCharId), "", true, Some(None))) )
+                    SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayerCharId, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                    JoinSquad(tplayer, squad, line)
+                    RemoveQueuedInvites(tplayer.CharId) //TODO deal with these somehow
+                  case _ => ;
+                }
+              case _ => ;
+            }
+
+          case Some(InviteForRole(invitingPlayer, name, guid, position)) if EnsureEmptySquad(invitedPlayer, msg) =>
+            squadFeatures.get(guid) match {
+              case Some(features) if JoinSquad(tplayer, features.Squad, position) =>
+                //join this squad
+                SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))) )
+                SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                RemoveQueuedInvites(tplayer.CharId)
+                features.ProxyInvites = Nil
+                features.SearchForRole = None
+                RemoveInvitesForSquadAndPosition(guid, position)
+
+              case Some(features) =>
+                //can not join squad; position is unavailable or other reasons block action
+                features.ProxyInvites = features.ProxyInvites.filterNot(_ == invitedPlayer)
+                NextInviteAndRespond(invitedPlayer)
+
+              case _ =>
+                //squad no longer exists?
+                NextInviteAndRespond(invitedPlayer)
+            }
+
+          case Some(ProximityInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer, msg) =>
+            squadFeatures.get(guid) match {
+              case Some(features) =>
+                val squad = features.Squad
+                if(squad.Size < squad.Capacity) {
+                  val positions = squad.Membership.zipWithIndex
+                    .collect { case (member, index) if member.CharId == 0 && squad.Availability(index) && {
+                      val requirementsToMeet = member.Requirements
+                      requirementsToMeet.intersect(tplayer.Certifications) == requirementsToMeet
+                    } =>
+                      (index, member.Requirements.size)
+                    }
+                    .sortBy({ case (_, requirements) => requirements })
+                  ((positions.headOption, positions.lastOption) match {
+                    case (Some((first, size1)), Some((_, size2))) if size1 == size2 => Some(first) //join the first available position
+                    case (Some(_), Some((last, _))) => Some(last) //join the most demanding position
+                    case _ => None //(None, None)
+                  }) match {
+                    case Some(position) if JoinSquad(tplayer, squad, position) =>
+                      //join this squad
+                      SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))) )
+                      SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                      RemoveQueuedInvites(invitedPlayer)
+                      features.ProxyInvites = features.ProxyInvites.filterNot(_ == invitedPlayer)
+                    case _ =>
                   }
-                case _ => ;
-              }
+                }
+                if(features.ProxyInvites.isEmpty) {
+                  //all invitations exhausted; this invitation period is concluded
+                  features.SearchForRole = None
+                }
+                else if(squad.Size == squad.Capacity) {
+                  //all available squad positions filled; terminate all remaining invitations
+                  features.SearchForRole = None
+                  features.ProxyInvites = Nil
+                  CleanupInvitesForSquad(guid)
+                  //CleanupInvitesFromPlayer(invitingPlayer)
+                }
 
-            case None =>
-              //the invite either timed-out or was withdrawn; select a new one?
-              NextInvite(invitedPlayer) match {
-                case Some(bid : BidForPosition) if !acceptedInvite.contains(bid) =>
-                  HandleBidForPosition(bid, tplayer)
-                case Some(bid) if !acceptedInvite.contains(bid) =>
-                  SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(invitedPlayer), bid.InviterName, false, Some(None))))
-                case None => ;
-              }
-          }
+              case _ =>
+                //squad no longer exists?
+                NextInviteAndRespond(invitedPlayer)
+            }
+
+          case _ =>
+            //the invite either timed-out or was withdrawn or is now invalid; select a new one?
+            NextInviteAndRespond(invitedPlayer)
         }
 
       case SquadAction.Membership(SquadRequestType.Leave, leavingPlayer, optionalPlayer, _, _) =>
